function BayesUpdateTopDown(pos,newp)

% Updates the probability of a node and recursively propagates the change to
% its descendants

%  pos: tree position where the sensing action took place
%  newp: new probability value triggering the change
%  indexes: boolean vector indicating which leaves were updated
%  returns oindexes: a boolean vector indicating which leaves were updated
%  (updated version of the input parameter)




global tree;
global lower_thresh;

%oindexes = indexes;
if newp == 1 || newp == 0
    return
end
powInc = log(1-newp)/log(1-tree(pos).p);

if(tree(pos).p > newp) %the reading was a miss
    tree(pos).negativeScans = tree(pos).negativeScans + 1;
else
    tree(pos).positiveScans = tree(pos).positiveScans + 1;
end

tree(pos).p = newp; % first set the new probability

if ( tree(pos).p > lower_thresh( tree(pos).depth ) )
    tree(pos).cleared = 0;
end

if tree(pos).leaf == 0 % internal node? Recursion
    p = [tree(tree(pos).NW).p tree(tree(pos).NE).p tree(tree(pos).SE).p tree(tree(pos).SW).p];
    p = 1 - ((1-p) .^powInc);
    BayesUpdateTopDown(tree(pos).NW,p(1));
    BayesUpdateTopDown(tree(pos).NE,p(2));
    BayesUpdateTopDown(tree(pos).SE,p(3));
    BayesUpdateTopDown(tree(pos).SW,p(4));
% else % leaf? Terminate and recall update
%     oindexes(pos) = 1;
end




