function [C,undetected,falsepositive] = ComputeDecisionCosts(reported,realLocations)

global epsilon;

global C00;
global C11;
global C10;
global C01;
global tree;

undetectedTargets = ones(1,size(realLocations,2));
C = 0;
falsepositive = 0;

for i = 1:size(reported,2)
    correct = 0;
    for j = 1:size(realLocations,2)
        if norm(reported(:,i)-realLocations(:,j)) < epsilon
            undetectedTargets(j) = 0;
            correct = 1;
        end
    end
    if ~ correct % error of type 1/0; false positive
        C = C + C10;
        falsepositive = falsepositive + 1;
        disp('False positive');
        t = FindPoint(reported(1,i),reported(2,i));
        fprintf('Node %d Depth %f Probability %f x=%f y=%f PS %d NS %d\n',...
            t,tree(t).depth,tree(t).p,tree(t).xc,tree(t).yc,...
            tree(t).positiveScans,tree(t).negativeScans);
%         tree(t).p
%         tree(t).leaf
%         tree(t).depth
    end
end

undetected = sum(undetectedTargets);
C = C + sum(undetected)*C01;  % errors of type 0/1; missed detection

if undetected > 0
    for i = 1:numel(undetectedTargets)
        if undetectedTargets(i)
            %if numel(realLocations) == 2
            %    t = FindPoint(realLocations(1),realLocations(2));
            %else
                t = FindPoint(realLocations(1,i),realLocations(2,i));
           % end
            disp('Undetected target');
            fprintf('Depth %f Probability %f x=%f y=%f PS %d NS %d\n',...
                    tree(t).depth,tree(t).p,tree(t).xc,tree(t).yc, ...
                    tree(t).positiveScans,tree(t).negativeScans);
        end
    end
end