function [dist, previous] = GetDijkstraInfo( source )

global tree;

%initialization
dist = ones(length(tree),1) * Inf;
previous = zeros(length(tree),1);
visisted = zeros(length(tree),1);
Q = 1:length(tree);
dist(source) = 0;

while ~isempty(Q)
    minIndex = 0;
    minValue = Inf;
    u = 0;
    for i=1:length(Q)
         if(dist(Q(i)) <= minValue)
             minIndex = i;
             minValue = dist(Q(i));
             u = Q(i);
         end
    end
    if minValue == Inf
        break;
    end
    Q(minIndex) = [];
    visisted(u) = 1;
    adjCells = FindAdjacentCells( u );
    for i=1:length(adjCells)
       v = adjCells(i);
       if visisted(v) == 0
           alt = dist(u) + Distance(u,v);
           if alt < dist(v)
               dist(v) = alt;
               previous(v) = u;
           end
       end
    end
end

end
