function [z,pos] = GetSensorReading(x,y,target)

%  x,y: sensing coordinates (must be valid values)
%  target: vector with target locations (vector format)

global tree;
global alpha;
global beta;

% find out where sensing happens
pos = LocateAndSplit(x,y);

ntargets = size(target,2);
ontarget = 0;
i = 1;

% determines if at least one target is inside sensing region
while i <= ntargets   % can't remember why I did'n use for, but there was a reason
    if inside([tree(pos).xmin tree(pos).xmax tree(pos).ymin ...
            tree(pos).ymax],target(:,i))
        ontarget = 1;
        i = ntargets+1;
    else
        i = i+1;
    end
    
end

depth = tree(pos).depth;% necessary to retrieve right values for alpha,beta
%fprintf('scan at depth:%d x:%f y:%f\n',depth,x,y);
roulette = rand(1); 
if ontarget  % 
    if roulette > beta(depth)
        z = 1; % correcty reports a target
    else
        z = 0; % missed target with probability beta
    end
else
    if roulette > alpha(depth) 
        z = 0; % correctly reports no target
    else
        z = 1; % false positive with probability beta
        %disp('false positive');
    end
end

function b = inside(bounds,point)
% determines if a point is inside a rectangle

if ( point(1) >= bounds(1) ) && ...
        ( point(1) <= bounds(2) ) && ...
        ( point(2) >= bounds(3) ) && ...
        ( point(2) <= bounds(4) )
    b = true;
else
    b = false;
end