function I = InformationGain( pos , z )
global tree;



newp = psi(z,pos)*tree(pos).p / ...
    ( phi(z,pos) * (1-tree(pos).p ) + psi(z,pos) * tree(pos).p );


%      I = H(tree(pos).p) - H(newp);
%
% for i=1:length(tree)
%     tree(i).tempP = tree(i).p;
% end

%loops are slow in matlab...
t = [tree(1:numel(tree)).p];
c = num2cell(t);
[tree(1:numel(tree)).tempP] = c{:};

tempUpdateTopDown(pos,newp)
%
% I = 0;
% for i=1:length(tree)
%     if tree(i).leaf == 1
%         I = I + H(tree(i).p) - H(tree(i).tempP);
%     end
% end

%loops are slow in matlab...
myI = 0;
p = [tree(1:numel(tree)).p];
tempP = [tree(1:numel(tree)).tempP];
l = [tree(1:numel(tree)).leaf];
p = p(l>0);
tempP = tempP(l>0);
p = myH(p);
tempP = myH(tempP);
I = sum(p-tempP);
% I = sum(myH(p)-myH(tempP));
%
%
%
% if abs(myI - I) > 1e-10
%     myI
%     I
%     abs(myI-I)
%     error('Error');
% % else
% %     I = myI;
% end
% %
end

function tempUpdateTopDown(pos,newp)
global tree;
% if newp == 1 || newp == 0
%     error('This shall not happen...');
% end

if newp == 1
   % powInc = 0;
   return
elseif newp == 0
   % powInc = 0; 
   return
else
    powInc = log(1-newp)/log(1-tree(pos).p);
end
tree(pos).tempP = newp; % first set the new probability

if tree(pos).leaf == 0 % internal node? Recursion
    p = [tree(tree(pos).NW).p tree(tree(pos).NE).p tree(tree(pos).SE).p tree(tree(pos).SW).p];
    p = 1 - ((1-p) .^powInc);
    tempUpdateTopDown(tree(pos).NW,p(1));
    tempUpdateTopDown(tree(pos).NE,p(2));
    tempUpdateTopDown(tree(pos).SE,p(3));
    tempUpdateTopDown(tree(pos).SW,p(4));
end
end


function f = phi(z,st)

global alpha;
global tree;

f = (1-z)*(1-alpha(tree(st).depth)) + z*alpha(tree(st).depth);
end

function f = psi(z,st)

global beta;
global tree;

f = (1-z)*beta(tree(st).depth) + z*(1-beta(tree(st).depth));
end