function [f h] = Initialize3DPlot(numRobots)

% draws the current quadtree. If called without g sets up the figure
% and returns the handle for successive calls, otherwise uses the passed
% handle.

% Should possibly be coded differently; very slow

global tree;
global xslices;
global yslices;
global maxDepth;
global oldleaf;


f = figure;
set(f, 'Position', [668 153 560 420]);
axis([tree(1).xmin tree(1).xmax tree(1).ymin tree(1).ymax 0 10*maxDepth]);
set(gca, 'XTick', 0:xslices/4:xslices, 'YTick', 0:yslices/4:yslices);
grid on
hold on

n = size(tree,2);
oldleaf = zeros(1,size(tree,2));
for i = 1:n
    
    if tree(i).leaf == 1
        h_line(1) = line([tree(i).xmin tree(i).xmax],[tree(i).ymin tree(i).ymin]);
        h_line(2) = line([tree(i).xmin tree(i).xmax],[tree(i).ymax tree(i).ymax]);
        h_line(3) = line([tree(i).xmin tree(i).xmin],[tree(i).ymin tree(i).ymax]);
        h_line(4) = line([tree(i).xmax tree(i).xmax],[tree(i).ymin tree(i).ymax]);
        set(h_line, 'Color', 'black');
        oldleaf(i) = 1;
    end
    
end
h = zeros(2,numRobots);
for i=1:numRobots
    h(1,i) = plot3(-100, -100, -100, 'ro', 'MarkerSize', 10, 'MarkerFaceColor', 'r' );  % searcher position
    h(2,i) = line([100 100],[100 100],[100 100]);
end