function PlotEstimate(gc)

% Plots the current posterior extracting values from the tree
% Important: it plots the probability of being occupied even though we
% propagate the posterior of being free
% Plots only values for the leafs
% gc: handle of the figure where to plot

global tree;
global xslices;
global yslices;

figure(gc);
set(gc, 'Position', [107 153 560 420]);

n = size(tree,2);

deltax = (tree(1).xmax-tree(1).xmin)/xslices;
deltay = (tree(1).ymax-tree(1).ymin)/yslices;

x = tree(1).xmin:deltax:tree(1).xmax;
y = tree(1).ymin:deltay:tree(1).ymax;

z = zeros(numel(y),numel(x));

for i = 1:n
    
    if tree(i).leaf == 1
        xind = find((x>tree(i).xmin)& (x<=tree(i).xmax) );
        yind = find((y>tree(i).ymin)& (y<=tree(i).ymax) );
        z(xind,yind) = tree(i).p; % probability of being occupied
        
    end
    
end


mesh(z')
axis([tree(1).xmin tree(1).xmax tree(1).ymin tree(1).ymax 0 max(max(max(z)),0.0001)]);

set(gca, 'XTick', 0:xslices/4:xslices, 'YTick', 0:yslices/4:yslices);

