path = '100RunsType2StoppingCriterion3Factor01';
startIndex = 51;
endIndex = 100;

global C00;
global C11;
global C10; % cost for false positive
global C01; % cost for missed detection
C11 = 0;
C00 = 0;
C10 = 1000;
C01 = 1;


global epsilon;
epsilon = 0.00001;

global tree;
% depth-dependent sensor performance
global alpha; % false positive
global beta;  % missed detection
% sensor perfomance
x = 1:10;
% alpha values parametrized by depth
alpha = 0.2 - 0.01*x;
% beta values parametrized by depth
beta = 0.3 - 0.02*x;

VariableTargets = load('TargetPositions.mat');
VariableTargets = VariableTargets.targets;

C = zeros(1,endIndex);
undetected = zeros(1,endIndex);
falsepositive = zeros(1,endIndex);


for i = startIndex:endIndex
    fileToLoad = sprintf('%s/RUN%i.mat',path,i)
    a = load(fileToLoad);
    tree = a.tree;
    realLocations = VariableTargets{i};
    reported = a.targetLocations;
    scanSequence = a.scanResult;
    for j = 1:numel(tree)
        if tree(j).depth == a.maxDepth % consider leaves at the deepest level only
            sensed = find(scanSequence(2,:)==j);
            if numel(sensed) ==0
                tree(j).decision = 0;
            else
                lastScan = sensed(end);
                z = scanSequence(1,lastScan);
                d = SetDecision(j,z);
            end
        end
    end
    
    d = [tree(1:numel(tree)).depth];
    maxDepthNodes = tree(d==9);
    decisions =  [maxDepthNodes(1:numel(maxDepthNodes)).decision];
    localized = maxDepthNodes(decisions>0);
    newLocations = [ localized(1:numel(localized)).xc ; localized(1:numel(localized)).yc ];
%     if sum(size(newLocations) ~= size(reported))>0
%         i
%         error('Different number targets found');
%     end
%     if sum(sum(newLocations ~= reported) )
%         error('Need to rerun tests!');
%     end
    
    [C(i),undetected(i),falsepositive(i)] = ComputeDecisionCosts(newLocations,realLocations);
    
end

figure ; plot(undetected(51:100))
legend('Missed detections');
figure ; plot(falsepositive(51:100))
legend('False positives');