function d = SetDecision(pos,z)

% Sets the decision variable for a node where sensing just occurred.
% Decision is based on risk/cost minimization

global tree;
global alpha;
global beta;

global C00;
global C11;
global C10;
global C01;

global maxDepth;

if ( tree(pos).depth < maxDepth ) % never call for an intruder if not at maximum depth
    tree(pos).decision = 0;
    return
end

%BayesRatio = ((C11-C01)*(1-tree(pos).p))/((C00-C10)*tree(pos).p);
BayesRatio = ((C11-C01)*tree(pos).p)/((C00-C10)*(1-tree(pos).p));

if ( z == 1 ) % detection
    % f is the ratio between false positive and correct detection
    f = alpha(tree(pos).depth)/(1-beta(tree(pos).depth));
else % no detection
    % f is the ratio between correct clear and missed detection
    f = (1-alpha(tree(pos).depth))/beta(tree(pos).depth);
end

if f > BayesRatio
    tree(pos).decision = 0;
else
    tree(pos).decision = 1;
end

d = tree(pos).decision;