path1 = '100RunsType2StoppingCriterion3Factor01';
path2 = '100RunsType2StoppingCriterion3Factor008';
path3 = '100RunsType2StoppingCriterion3Factor005';

startIndex = 1;
endIndex = 100;

undetected = zeros(1,endIndex);
falsepositive = zeros(1,endIndex);
costs = zeros(1,endIndex);
ticks = zeros(1,endIndex);
nodes1 = zeros(1,endIndex);
nodes2 = zeros(1,endIndex);
nodes3 = zeros(1,endIndex);

maxTicks = 25000;

global C00;
global C01;
global C10;
global C11;

global tree;

C11 = 0;
C00 = 0;
C10 = 10;
C01 = 1000;

global epsilon;
epsilon = 0.00001;

stopEpsilon = 0.08;

for i = startIndex:endIndex
    fileToLoad = sprintf('%s/RUN%i.mat',path1,i);
    a = load(fileToLoad);
    tree = a.tree;
    nodes1(i) = numel(a.tree);
    
     fileToLoad = sprintf('%s/RUN%i.mat',path2,i);
    a = load(fileToLoad);
    tree = a.tree;
    nodes2(i) = numel(a.tree);
    
     fileToLoad = sprintf('%s/RUN%i.mat',path3,i);
    a = load(fileToLoad);
    tree = a.tree;
    nodes3(i) = numel(a.tree);
   
    %epsilonvalue = a.stop_epsilon;
    [costs(i),undetected(i),falsepositive(i)] = ComputeDecisionCosts(a.targetLocations,a.target);
    ticks(i) = maxTicks - a.TicksAllowed;
    if ticks(i) > 250000
        disp('Undetected because overtime');
    end
    
end

figure ; hist(costs); legend('Cost distribution');
figure ; hist(undetected); legend('Undetected targets');
figure ; hist(falsepositive); legend('False positives');
figure ; hist(ticks); legend('Time');
figure ; hist([nodes1' nodes2' nodes3'],10); legend('\varepsilon=0.1','\varepsilon=0.08','\varepsilon=0.05');


fprintf('%f & %f & %d & %d & %d & %d\\\\',stopEpsilon, mean(ticks),numel(find(ticks>maxTicks)),mean(costs),sum(falsepositive),sum(undetected));