% this script generates N random placements for the targets
% Relevant parameters
% L: edge of the search area (must be a power of two)
% T: average number of targets
% N: number of test cases to generate
% FileName: file where results should be save

L = 256;
T = 5;
N = 500;
FileName = 'TargetPositions.mat';

p = 5 / L^2; % p parameter for the binomial of parameters T,p

targets = cell(1,N);

for i = 1:N
    
    % nT: number of targets in current run; drawn from a binomial
    % distribution of paramters (L^2,p);
    nT = binornd(L^2,p);
    
    positions = zeros(2,nT);
    
    hits = zeros(L,L);
    j = 1;
    
    while j <= nT
        % generate valid random positions
        positions(:,j) = ceil(rand(2,1)*L)-0.5;
        % makes sure it was not generated before
        if hits(ceil(positions(1,j)),ceil(positions(2,j))) == 0
            hits(ceil(positions(1,j)),ceil(positions(2,j))) = 1;
            j = j+1;
        end
    end
    
    targets{i} = positions;
    
end

save(FileName,'targets');